//#12.00Aa WDSaisie.JS
//VersionVI: 30F180063c x
// Le seul support technique disponible pour cette librairie est
// accessible a travers le service "Assistance Directe".

// Manipulation d'un champ de saisie
function WDSaisie (sAliasChamp, sIndication)
{
	// Le champ de saisie est un lment du formulaire
	this.m_sAlias = sAliasChamp;
	if (sIndication.length > 0)
	{
		this.m_sIndication = sIndication;
	}
}

WDSaisie.prototype =
{
//	m_sAlias:		"",
//	m_oChamp:		null,
//	m_sIndication:	"",
//	m_nCouleur:		undefined,
//	m_sStylePolice:	undefined,
	m_sIndicationCouleur:	"#808080",
	m_sIndicationStyleF:	"italic",

	Init:function ()
	{
		this.m_oChamp = document.getElementsByName(this.m_sAlias)[0];

		// Place l'indication si besoin
		if (this.m_sIndication)
		{
			if (this.m_oChamp.value.length == 0)
			{
				// Supprime le focus
				this.m_oChamp.blur();
				// Place l'indication
				this.m_oChamp.value = this.m_sIndication;

				// Modifie le style
				this._SetStyle();
			}
		}
	},
	
	// Affiche le style de l'indication
	_SetStyle:function ()
	{
		// Sauve la couleur et le style de la police
		var oStyle = _JGCS(this.m_oChamp);
		this.m_nCouleur = oStyle.color;
		this.m_sStylePolice = oStyle.fontStyle;

		// Et met les styles demand
		this.m_oChamp.style.color = this.m_sIndicationCouleur;
		this.m_oChamp.style.fontStyle = this.m_sIndicationStyleF;
	},

	// Supprime le style de l'indication
	_ClearStyle:function ()
	{
		// Restaure la couleur et le style de la police
		var oStyle = _JGCS(this.m_oChamp);
		// Sauf si la couleur  t entre temps par programmation
		if (oStyle.color == this.m_sIndicationCouleur)
		{
			this.m_oChamp.style.color = this.m_nCouleur;
			delete this.m_nCouleur;
		}
		// Pareil pour le style de la police
		if (oStyle.fontStyle == this.m_sIndicationStyleF)
		{
			this.m_oChamp.style.fontStyle = this.m_sStylePolice;
			delete this.m_sStylePolice;
		}
	},

	// Lecture de la valeur du champ en programmation : supprime l'indication si elle est affiche
	TraiteGetValeur:function (sValeur)
	{
		if (this.m_sIndication)
		{
			return (sValeur != this.m_sIndication) ? sValeur : "";
		}
		return sValeur;
	},

	// Ecriture de la valeur du champ en programmation : ajoute l'indication si besoin ou supprime le style de l'indication
	TraiteSetValeur:function (sValeur)
	{
		if (this.m_sIndication)
		{
			// Si la valeur est vide => Affiche l'indication
			if (sValeur.length == 0)
			{
				// Si la valeur affich n'est pas dj l'indication
				if (this.m_oChamp.value != this.m_sIndication)
				{
					// Affiche l'indication : pas besoin de l'afficher : le code autour le fera pour nous => on met juste le style
					this._SetStyle();
				}
				// Dans tout les cas retourne l'indication car c'est la valeur finalement dans le champ
				return this.m_sIndication;
			}

			// La valeur est non vide : il faut supprimer l'indication si besoin
			if (String(this.m_oChamp.value) == this.m_sIndication)
			{
				this._ClearStyle();
			}
		}
		
		// Dans tous les cas : retourne la vraie valeur
		return sValeur;
	},

	// Fonction appel quand le champ recoit le focus : supprime l'indication si besoin
	TraiteFocus:function ()
	{
		if (this.m_sIndication)
		{
			// Il faut supprimer l'indication si besoin
			if (this.m_oChamp.value == this.m_sIndication)
			{
				this._ClearStyle();
				this.m_oChamp.value = "";
			}
		}
	},

	// Fonction appel quand le champ perd le focus : remet l'indication si besoin
	TraiteBlur:function ()
	{
		if (this.m_sIndication)
		{
			// Il faut remettre l'indication si besoin
			if (this.m_oChamp.value == "")
			{
				this._SetStyle();
				this.m_oChamp.value = this.m_sIndication;
			}
		}
	},

	// Fonction appel en submit de la page : supprime l'indication pour ne pas l'envoyer au serveur
	TraiteSubmit:function ()
	{
		if (this.m_sIndication)
		{
			// Il faut supprimer l'indication si besoin
			if (this.m_oChamp.value == this.m_sIndication)
			{
				this._ClearStyle();
				this.m_oChamp.value = "";
			}
		}
	}
}
